 
'use strict';

/* for getFunctionParameters e.g */
var STRIP_COMMENTS = /((\/\/.*$)|(\/\*[\s\S]*?\*\/))/mg;
var ARGUMENT_NAMES = /(?:^|,)\s*([^\s,=]+)/g;
var EventEmitter = require('@frdl/eventemitter');
var Webfan = require('@frdl/webfan');
var overload = require('@betafcc/overload');
var frdl = {
  browser : {},
  overload : overload
};
frdl.overload.add = function(/*O, name, cases*/){			
	var args = Array.prototype.slice.call(arguments);			
	var O = args.shift();		
	var name = args.shift();		
	var cases = args.shift();				
	O[name] = this.apply(O,Array.prototype.slice.call(cases));
	return O;
};
frdl.cbs = {};
frdl.clone=clone;
frdl.extend=extend;
frdl.str_replace = str_replace;
frdl.html_entity_decode = html_entity_decode;
frdl.get_html_translation_table = get_html_translation_table;
frdl.base64_encode = base64_encode;
frdl.base64_decode = base64_decode;
frdl.base64_detect = base64_detect;
frdl.explode = explode;
frdl.htmlentities = htmlentities;
frdl.dashToCamel = dashToCamel;
frdl.camelToDash = camelToDash;
frdl.mt_rand = mt_rand;
frdl.urlencode = urlencode;
frdl.urldecode = urldecode;
frdl.hexdec=hexdec;
frdl.dechex=dechex;
frdl.strip_tags = strip_tags;
frdl.strpos = strpos;
frdl.ucfirst=ucfirst;
frdl.stripslashes=stripslashes;
frdl.WebfanCreateCookie = WebfanCreateCookie;     
frdl.WebfanCreateCookieSeconds = WebfanCreateCookieSeconds;       
frdl.WebfanReadCookie = WebfanReadCookie;     
frdl.WebfanEraseCookie = WebfanEraseCookie; 
frdl.sanitize=sanitize;
frdl.microtime = microtime;
frdl.$q = $q;
frdl.createJavascriptObjectURL=createJavascriptObjectURL;															  
frdl.createHTMLObjectURL=createHTMLObjectURL;														  
frdl.createCSSObjectURL=createCSSObjectURL;	
frdl.createImageObjectURL=createImageObjectURL;			  
frdl.linkBLOB=__createObjectURL;	              
frdl.extractTextBetween = extractTextBetween;
frdl.preg_quote=preg_quote;     

 
frdl.getFunctionParameters = getFunctionParameters; 
           
frdl.Reflector = {};           
frdl.Reflector.getFunctionParameters = getFunctionParameters;          
frdl.Reflector.removeCommentsFromSource=removeCommentsFromSource;        
frdl.Reflector.getFunctionBody = getFunctionBody;        
frdl.Reflector.getFunctionName = getFunctionName;

   


//frdl.EventEmitter = EventEmitter; 
		
frdl.MagicHelper = { };		
frdl.EventEmitter = EventEmitter; 

frdl.MagicHelper.emitter=new EventEmitter;

frdl.MagicHelper.addMethodCallback = addMethodCallback; 		


				  
													  
													  

frdl.formatBytes = function(bytes,decimals) {
   if(bytes == 0) return '0 Byte';
  // var k = 1000; // or 1024 for binary
   var k = 1024;
   var dm = decimals + 1 || 3;
   var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
   var i = Math.floor(Math.log(bytes) / Math.log(k));
   return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
};
	
			
									  
           
	
  function getFrame(){
                                    
                          return requestAnimationFrame || window.requestAnimationFrame || window.mozRequestAnimationFrame ||
                            window.webkitRequestAnimationFrame || window.msRequestAnimationFrame

                              || function(callback){
                                    return setTimeout(callback, 0); 
                            };
  };


 function cancelFrame(){
                                    
                          var f = cancelAnimationFrame || window.cancelAnimationFrame || window.mozCancelAnimationFrame
                                   ||  clearTimeout
                              ;     
                           
                          return function(frame){
                                    try{
                                        return f(frame);
                                    }catch(e){
                                        if(!!console)console.log(e);
                                    }
                          };
  };   
frdl.browser.getFrame = getFrame;
frdl.browser.cancelFrame = cancelFrame;
	
	
 
         
//});



  



                frdl.isTraversable = function(thing) {
                    return (('object' === typeof thing || 'array' === typeof thing) && null !== thing) ? true : false;
                };


                frdl.array_unique = function(array) {
                    return ("undefined" === typeof jQuery) ? array.filter(function(el, i, array) {
                        return i === arr.indexOf(el);
                    }) : $.grep(array, function(el, i) {
                        return i === $.inArray(el, array);
                    });
                };
                frdl.filterArray = function(arr, filter) {
                    var o = [];
                    for (var index = 0; index < arr.length; index++) {
                        if (filter(arr[index], index) === true) {
                            o.push(arr[index]);
                        }
                    }
                    return o;
                };
                frdl.shuffleArray = function(a) {
                    var j, x, i;
                    for (i = a.length; i; i--) {
                        j = Math.floor(Math.random() * i);
                        x = a[i - 1];
                        a[i - 1] = a[j];
                        a[j] = x;
                    }
                };
                frdl.filterObject = function(arr, filter) {
                    var o = {};
                    for (var k in arr) {
                        if (filter(arr[k], k) === true) {
                            o[k] = arr[k];
                        }
                    }
                    return o;
                };
                frdl.filter = function(arr, filter, recursive) {
                    if (true === recursive && true === frdl.isTraversable(arr)) {
                        arr = frdl.each(arr, function(i, v) {
                            arr[i] = frdl.filter(v, filter, recursive);
                        });
                        return arr;
                    }
                    if ('array' === typeof arr) {
                        return frdl.filterArray(arr, filter);
                    } else if ('object' === typeof arr) {
                        return frdl.filterObject(arr, filter);
                    } else {
                        return (true === filter(arr)) ? arr : undefined;
                    }
                };
                frdl.each = function(object, callback, args) {
                    var name, i = 0,
                        length = ('undefined' !== typeof object && 'undefined' !== typeof object.length) ? object.length : undefined,
                        traversable = false;
                    if (true !== frdl.isTraversable(object)) {
                        traversable = false;
                    } else {
                        traversable = true;
                    }
                    if (args) {
                        if (false === traversable) {
                            callback.apply(object, args);
                            return object;
                        }
                        if (length === undefined) {
                            for (name in object)
                                if (callback.apply(object[name], args) === false)
                                    break;
                        } else
                            for (; i < length;)
                                if (callback.apply(object[i++], args) === false)
                                    break;
                    } else {
                        if (false === traversable) {
                            callback.call(object, 0, object);
                            return object;
                        }
                        if (length === undefined) {
                            for (name in object)
                                if (callback.call(object[name], name, object[name]) === false)
                                    break;
                        } else
							var value;
                            for ( value = object[0]; i < length && callback.call(value, i, value) !== false; value = object[++i]) {}
                    }
                    return object;
                };
           													  
					 
		      frdl.cssImportString = function(css){
                  frdl.getCSS(frdl.createCSSObjectURL(css)); 
				  return css;
             };								  
								  
			frdl.urlRewriteCss = function(c, base, ___URL){
				  if('undefined' === typeof ___URL){
					 var ___URL = global.require('url');  
				  }
				
  	                             var urlMatchingRegex = /[:,\s]\s*url\s*\(\s*(?:'(\S*?)'|"(\S*?)"?|((?:\\\s|\\\)|\\\"|\\\'|\S)*?))\s*\)/gi;
                                    c = c.replace(urlMatchingRegex, function(fullMatch, url) {
                                        var n = frdl.str_replace('"', "'", fullMatch);
                                        return n;
                                    });
                                    c = c.replace(urlMatchingRegex, function(fullMatch, url) {
                                    
                                       var __U = ___URL;
                                        if ('undefined' === typeof url) {
                                            var _u = frdl.explode('(', fullMatch, 2)[1];
                                            var url = _u.substr(0, _u.length - 1);
                                        }
                                        if ('data:' === url.substr(0, 'data:'.length)) {
                                            return fullMatch;
                                        }
                                        try {
                                            var nu = __U.parse(base).resolve(url);
                                        } catch (err) {
                                            var nu = (base) + url;
                                            if (1 < frdl.debug.mode())
                                                console.warn(err);
                                        }
										
										var ext = __U.parse(nu).pathname.split(/\./).pop();
										if('woff'===ext || 'woff2' === ext){
										    return '';	
										}
										
                                        var nt = frdl.str_replace(url, nu, fullMatch);
                                        return nt;
								});
	                return c;							
           };										  
		













(function(obj, method){

	
//	Symbol.frdl = 'MONKEY.Patch.Promise.State'; 
	 

function getPromiseState(aPromise){


 var promiseState = function*promiseState(p) {
   const t = {};
   var P = "unknown";
   P = Promise.race([p, t])
    .then(v => (v === t)? "pending" : "fulfilled", () => "rejected");
  
   yield P.then(function(s){
    //   P[Symbol.frdl.MONKEY.Patch.Promise.State.valueOf()] = s;
	    P[Symbol.for('frdl.MONKEY.Patch.Promise.State')] = s;
       return P;
   });

   yield P;
 };



 var Gen = promiseState(aPromise);
 var s = Gen.next(); 
  s = Gen.next();
 return s.value;
}


var fn = function(myPromise){
 var test = getPromiseState(myPromise);
 var stat = test;
 return stat;
};



var fn2 = function(myPromise){
 myPromise.isPending = function(){ 
	 return true === this instanceof Promise && global.require('util').inspect(this).indexOf("<pending>") > -1; 
 };
 myPromise.isRejected = function(){ 
	 return require('util').inspect(this).indexOf("<rejected>") > -1; 
 };
 myPromise.isResolved = function(){ 
	 return false === this instanceof Promise || global.require('util').inspect(this).indexOf("<resolved>") > -1; 
 };
	
 myPromise.value = function(){ 
	 if( false === this instanceof Promise || global.require('util').inspect(this).indexOf("<resolved>") > -1 ){
		 this.valueOf();
	 }else{
		 return new Error('<pending>');
	 }
 };	
	
	
 return myPromise;
};


obj[method] = function(myPromise){
 var myPromiseStat = fn2(myPromise); 
 return myPromiseStat; 
};


}(frdl, 'getPromiseState'));
								


																  
	frdl.cssImportLink = function(url){	
	  return new Promise(function(resolve, reject){	
		global.requirejs(['loadPlain!'+url], function(css){	
			resolve(frdl.cssImportString(frdl.urlRewriteCss(css.content,  global.requirejs.toUrl(require('url').resolve(url, './')), global.require('url')) ));   	
		});   		
	  });
   };		

																  
	//for browser ctx...															  
																  
   










   frdl.getCSS = function(src, p, once) {

         //    if(false===frdl.browser)throw 'Cannot frdl.getCSS() in NO_BROWSER context!';


                    (frdl.ready || global.process.ready)(function() {
                        if ('undefined' === typeof once || true === once || true === p) {
                            if (null !== document.querySelector('link[href="' + frdl.str_replace('/', '\/', src) + '"]')) {
                                return;
                            }
                        }
                        if ('undefined' === typeof p || null === p || true === p)
                        var p = document.querySelector('head');
                        var style = document.createElement('link');
                        style.setAttribute('type', 'text/css');
                        style.setAttribute('rel', 'stylesheet');
                        style.setAttribute('href', src);
						p.append(style)										   
                    });
                 return frdl;
  };

																  
														  
																  
																  
																  
																  
																  
                
                (function() {
                    var lastTime = 0;
                    var vendors = ['ms', 'moz', 'webkit', 'o'];
                    for (var x = 0; x < vendors.length && !global.requestAnimationFrame; ++x) {
                        global.requestAnimationFrame = global[vendors[x] + 'RequestAnimationFrame'];
                        global.cancelAnimationFrame = global[vendors[x] + 'CancelAnimationFrame'] || global[vendors[x] + 'CancelRequestAnimationFrame'];
                    }
                    if (!global.requestAnimationFrame)
                        global.requestAnimationFrame = function(callback, element) {
                            var currTime = new Date().getTime();
                            var timeToCall = Math.max(0, 16 - (currTime - lastTime));
                            var id = global.setTimeout(function() {
                                callback(currTime + timeToCall);
                            }, timeToCall);
                            lastTime = currTime + timeToCall;
                            return id;
                        };
                    if (!global.cancelAnimationFrame)
                        global.cancelAnimationFrame = function(id) {
                            clearTimeout(id);
                        };
                    var requestAnimationFrame = global.requestAnimationFrame;
                    var cancelAnimationFrame = global.cancelAnimationFrame;
                    frdl.requestAnimationFrame = function(callback) {
                        return requestAnimationFrame.call(window, callback);
                    };
                    frdl.cancelAnimationFrame = function(id) {
                        return cancelAnimationFrame.call(window, id);
                    };
                }());
     















            frdl.getScript=function(url, callBack, doNotRemove, prepend, args) {
                var scripts = document.querySelectorAll('script');
                if ('undefined' === typeof doNotRemove || true === doNotRemove) {
                    for (var i = 0; i < scripts.length; i++) {
                        if (url === scripts[i].getAttribute('src')) {
                            if (typeof callBack === "function" &&  scripts[i].readyState === "complete") {
                                callBack.apply(this, args);
                                  return "undefined";
                            }
                          
                        }
                    }
                }
                var head = document.querySelector("head");
                var script = document.createElement("script");
                script.setAttribute('src', url);
                script.setAttribute('async', 'true');
                var done = false,
                    persistent = ('undefined' === typeof doNotRemove || true === doNotRemove) ? true : false;
                script.setAttribute('type', 'text/javascript');
                /*
                script.onload = script.onreadystatechange = function() {
                    if (!done && (
                   // !this.readyState || this.readyState === "loaded" ||
                     this.readyState === "complete")) {
                        done = true;
                        if (true !== persistent) {
                            script.onload = script.onreadystatechange = null;
                            head.removeChild(script);
                        }
                        if (typeof callBack === "function") {
                            callBack.apply(this, args);
                        }
                    }
                };
                */
                script.onload =  function() {
   
                        done = true;
                        if (true !== persistent) {
                            script.onload = script.onreadystatechange = null;
                            head.removeChild(script);
                        }
                        if (typeof callBack === "function") {
                            callBack.apply(this, args);
                        }
                   
                };
                
                if (true === prepend) {
                    head.insertBefore(script, head.firstChild);
                } else {
                    head.appendChild(script);
                }
                return "undefined";
            };													  
								

exports = module.exports = frdl;



function microtime() {
    return (new Date() / 1000);
}													  
				
function sanitize(o){
 return JSON.parse(JSON.stringify(o));	
}
function $q(q, all, context) {
                if ('undefined' === typeof context)
                    var context = document;
                var m = ((false === all) ? 'querySelector' : 'querySelectorAll');
  return context[m](q);
}       
function removeCommentsFromSource(str) {
   return str.replace(/(?:\/\*(?:[\s\S]*?)\*\/)|(?:([\s;])+\/\/(?:.*)$)/gm, '$1');
}		
function getFunctionBody(fn) {
		        if ('function'===typeof fn) {
            	 	 fn = fn.toString();
            	 }												  
													  
            	 if (typeof fn != 'string') {
            	 	  return undefined;
            	 }												  
													  
        var s = removeCommentsFromSource( fn );
 return s.substring(s.indexOf('{')+1, s.lastIndexOf('}'));
}
function getFunctionName(fn, inspectBody) {
	              if ('function'===typeof fn) {
            	 	 fn = fn.toString();
            	 }												  
													  
            	 if (typeof fn !== 'string') {
            	 	  return undefined;
            	 }
													  
				 if(true!==!!inspectBody){
				     fn = str_replace(getFunctionBody(fn), '\n', fn);
			     }
													  
            	// var result = fn.match(/function\s*(\S+)\s*\(/);
            	var result = fn.match(/function\s*(\S+)\s*\(|\(\)\=\>\s*(\S+)\s*\(/);
            	 if (!result) {
            	 	  return '';
            	 	   }
            	 	   return result[1];
}
function getFunctionParameters(func, wrapStart, wrapEnd) {
	              if ('function'===typeof func) {
            	 	 func = func.toString();
            	 }												  
													  
            	 if (typeof func != 'string') {
            	 	  return undefined;
            	 }

                var fnStr = func.replace(STRIP_COMMENTS, '');
                var argsList = fnStr.slice(fnStr.indexOf('(') + 1, fnStr.indexOf(')'));
                var result = argsList.match(ARGUMENT_NAMES);
                if (result === null) {
                    return [];
                } else {
                    var stripped = [];
                    for (var i = 0; i < result.length; i++) {
                        stripped.push((('string' === typeof wrapStart) ? wrapStart : '') + result[i].replace(/[\s,]/g, '') + (('string' === typeof wrapEnd) ? wrapEnd : ''));
                    }
                    return stripped;
                }
}
 function extend(from, to) {
          if (from === null || typeof from !== 'object')
                    return from;
         if (from.constructor !== Object && from.constructor !== Array)
                    return from;
         if (from.constructor === Date || from.constructor === RegExp || from.constructor === Function || from.constructor === String || from.constructor === Number || from.constructor === Boolean)
                    return new from.constructor(from);
                to = to || new from.constructor();
                var name;
                for (name in from) {
                    to[name] = typeof to[name] === 'undefined' ? extend(from[name], null) : to[name];
                }
                return to;
 }

function clone(obj) {
    var clone = extend(obj);
    return clone;
}


 function WebfanCreateCookie(name,value,days) {
	if (days) {
		var date = new Date();
		date.setTime(date.getTime()+(days*24*60*60*1000));
		var expires = "; expires="+date.toGMTString();
	}
	else var expires = "";

	var h = location.host.split(".");

	document.cookie = name+"="+value+expires+";domain=."+h[h.length-2]+"."+h[h.length-1]+";path=/";
	document.cookie = name+"="+value+expires+";domain=.webfan.de;path=/";
}



function WebfanCreateCookieSeconds(name,value,s) {
	if (s) {
		var date = new Date();
		date.setTime(date.getTime()+(s*1000));
		var expires = "; expires="+date.toGMTString();
	}else var expires = "";
	

	var h = location.host.split(".");

	document.cookie = name+"="+value+expires+";domain=."+h[h.length-2]+"."+h[h.length-1]+";path=/";
}


function WebfanReadCookie(name) {
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for(var i=0;i < ca.length;i++) {
		var c = ca[i];
		while (c.charAt(0)==' ') c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	return null;
}



function WebfanEraseCookie(name) {
	WebfanCreateCookie(name,"",-1);
}   















/*! frdl.ns.SFRDL (Frdl Standard Library) */
/*! http://locutus.io/php */
											 
											 
											 
											 
            function html_entity_decode(string, quote_style) {
                var hash_map = {},
                    symbol = '',
                    tmp_str = '',
                    entity = '',
                    tmp_str = string.toString();
                if (false === (hash_map = get_html_translation_table('HTML_ENTITIES', quote_style))) {
                    return false;
                }
                delete(hash_map['&']);
                hash_map['&'] = '&amp;';
                for (symbol in hash_map) {
                    entity = hash_map[symbol];
                    tmp_str = tmp_str.split(entity).join(symbol);
                }
                tmp_str = tmp_str.split('&#039;').join("'");
                return tmp_str;
            }

            function get_html_translation_table(table, quote_style) {
                var entities = {},
                    hash_map = {},
                    decimal;
                var constMappingTable = {},
                    constMappingQuoteStyle = {};
                var useTable = {},
                    useQuoteStyle = {};
                constMappingTable[0] = 'HTML_SPECIALCHARS';
                constMappingTable[1] = 'HTML_ENTITIES';
                constMappingQuoteStyle[0] = 'ENT_NOQUOTES';
                constMappingQuoteStyle[2] = 'ENT_COMPAT';
                constMappingQuoteStyle[3] = 'ENT_QUOTES';
                useTable = !isNaN(table) ? constMappingTable[table] : table ? table.toUpperCase() : 'HTML_SPECIALCHARS';
                useQuoteStyle = !isNaN(quote_style) ? constMappingQuoteStyle[quote_style] : quote_style ? quote_style.toUpperCase() : 'ENT_COMPAT';
                if (useTable !== 'HTML_SPECIALCHARS' && useTable !== 'HTML_ENTITIES') {
                    return false;
                }
                entities['38'] = '&amp;';
                if (useTable === 'HTML_ENTITIES') {
                    entities['160'] = '&nbsp;';
                    entities['161'] = '&iexcl;';
                    entities['162'] = '&cent;';
                    entities['163'] = '&pound;';
                    entities['164'] = '&curren;';
                    entities['165'] = '&yen;';
                    entities['166'] = '&brvbar;';
                    entities['167'] = '&sect;';
                    entities['168'] = '&uml;';
                    entities['169'] = '&copy;';
                    entities['170'] = '&ordf;';
                    entities['171'] = '&laquo;';
                    entities['172'] = '&not;';
                    entities['173'] = '&shy;';
                    entities['174'] = '&reg;';
                    entities['175'] = '&macr;';
                    entities['176'] = '&deg;';
                    entities['177'] = '&plusmn;';
                    entities['178'] = '&sup2;';
                    entities['179'] = '&sup3;';
                    entities['180'] = '&acute;';
                    entities['181'] = '&micro;';
                    entities['182'] = '&para;';
                    entities['183'] = '&middot;';
                    entities['184'] = '&cedil;';
                    entities['185'] = '&sup1;';
                    entities['186'] = '&ordm;';
                    entities['187'] = '&raquo;';
                    entities['188'] = '&frac14;';
                    entities['189'] = '&frac12;';
                    entities['190'] = '&frac34;';
                    entities['191'] = '&iquest;';
                    entities['192'] = '&Agrave;';
                    entities['193'] = '&Aacute;';
                    entities['194'] = '&Acirc;';
                    entities['195'] = '&Atilde;';
                    entities['196'] = '&Auml;';
                    entities['197'] = '&Aring;';
                    entities['198'] = '&AElig;';
                    entities['199'] = '&Ccedil;';
                    entities['200'] = '&Egrave;';
                    entities['201'] = '&Eacute;';
                    entities['202'] = '&Ecirc;';
                    entities['203'] = '&Euml;';
                    entities['204'] = '&Igrave;';
                    entities['205'] = '&Iacute;';
                    entities['206'] = '&Icirc;';
                    entities['207'] = '&Iuml;';
                    entities['208'] = '&ETH;';
                    entities['209'] = '&Ntilde;';
                    entities['210'] = '&Ograve;';
                    entities['211'] = '&Oacute;';
                    entities['212'] = '&Ocirc;';
                    entities['213'] = '&Otilde;';
                    entities['214'] = '&Ouml;';
                    entities['215'] = '&times;';
                    entities['216'] = '&Oslash;';
                    entities['217'] = '&Ugrave;';
                    entities['218'] = '&Uacute;';
                    entities['219'] = '&Ucirc;';
                    entities['220'] = '&Uuml;';
                    entities['221'] = '&Yacute;';
                    entities['222'] = '&THORN;';
                    entities['223'] = '&szlig;';
                    entities['224'] = '&agrave;';
                    entities['225'] = '&aacute;';
                    entities['226'] = '&acirc;';
                    entities['227'] = '&atilde;';
                    entities['228'] = '&auml;';
                    entities['229'] = '&aring;';
                    entities['230'] = '&aelig;';
                    entities['231'] = '&ccedil;';
                    entities['232'] = '&egrave;';
                    entities['233'] = '&eacute;';
                    entities['234'] = '&ecirc;';
                    entities['235'] = '&euml;';
                    entities['236'] = '&igrave;';
                    entities['237'] = '&iacute;';
                    entities['238'] = '&icirc;';
                    entities['239'] = '&iuml;';
                    entities['240'] = '&eth;';
                    entities['241'] = '&ntilde;';
                    entities['242'] = '&ograve;';
                    entities['243'] = '&oacute;';
                    entities['244'] = '&ocirc;';
                    entities['245'] = '&otilde;';
                    entities['246'] = '&ouml;';
                    entities['247'] = '&divide;';
                    entities['248'] = '&oslash;';
                    entities['249'] = '&ugrave;';
                    entities['250'] = '&uacute;';
                    entities['251'] = '&ucirc;';
                    entities['252'] = '&uuml;';
                    entities['253'] = '&yacute;';
                    entities['254'] = '&thorn;';
                    entities['255'] = '&yuml;';
                }
                if (useQuoteStyle !== 'ENT_NOQUOTES') {
                    entities['34'] = '&quot;';
                }
                if (useQuoteStyle === 'ENT_QUOTES') {
                    entities['39'] = '&#39;';
                }
                entities['60'] = '&lt;';
                entities['62'] = '&gt;';
                for (decimal in entities) {
                    if (entities.hasOwnProperty(decimal)) {
                        hash_map[global.String.fromCharCode(decimal)] = entities[decimal];
                    }
                }
                return hash_map;
            }

            function htmlentities(string, quote_style, charset, double_encode) {
                var hash_map = get_html_translation_table('HTML_ENTITIES', quote_style),
                    symbol = '';
                string = string == null ? '' : string + '';
                if (!hash_map) {
                    return false;
                }
                if (quote_style && quote_style === 'ENT_QUOTES') {
                    hash_map["'"] = '&#039;';
                }
                if (!!double_encode || double_encode == null) {
                    for (symbol in hash_map) {
                        if (hash_map.hasOwnProperty(symbol)) {
                            string = string.split(symbol).join(hash_map[symbol]);
                        }
                    }
                } else {
                    string = string.replace(/([\s\S]*?)(&(?:#\d+|#x[\da-f]+|[a-zA-Z][\da-z]*);|$)/g, function(ignore, text, entity) {
                        for (symbol in hash_map) {
                            if (hash_map.hasOwnProperty(symbol)) {
                                text = text.split(symbol).join(hash_map[symbol]);
                            }
                        }
                        return text + entity;
                    });
                }
                return string;
            }

            function mt_rand(min, max) {
                var argc = arguments.length;
                if (argc === 0) {
                    min = 0;
                    max = 2147483647;
                } else if (argc === 1) {
                    min = 0;
                    max = min;
                } else if (min < max) {
                    min = parseInt(min);
                    max = parseInt(max);
                } else {
                    min = 0;
                    max = 2147483647;
                }
                return Math.floor(Math.random() * (max - min + 1)) + min;
            }


            function strpos(haystack, needle, offset) {
                var i = (haystack + '').indexOf(needle, (offset || 0));
                return i === -1 ? false : i;
            }




       

 

            function urlencode(str) {
                str = (str + '').toString();
                return encodeURIComponent(str).replace(/!/g, '%21').replace(/'/g, '%27').replace(/\(/g, '%28').replace(/\)/g, '%29').replace(/\*/g, '%2A').replace(/%20/g, '+');
            }

            function urldecode(str) {
                return decodeURIComponent((str + '').replace(/\+/g, '%20'));
            }



            function strip_tags(str, allow) {
                var allow = (((allow || "") + "").toLowerCase().match(/<[a-z][a-z0-9]*>/g) || []).join('');
                var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi;
                var commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;
                return str.replace(commentsAndPhpTags, '').replace(tags, function($0, $1) {
                    return allow.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : '';
                });
            }											 
											 
											 
											 
											 
														  
  function createImageObjectURL(Image, type){
     if(true!== Image instanceof Blob){
              Image = new Blob([Image], {
                    type: type
             });
     }
     return URL.createObjectURL(Image);
  }														  
													 
											 
														  
  function createJavascriptObjectURL(func){
     var functionBody = frdl.Reflector.getFunctionBody(func);
     return URL.createObjectURL(new Blob([functionBody], {
       type: "text/javascript"
    }));
  }												  
				
							  
													  
													  
														  
  function createHTMLObjectURL(HTML){
     return URL.createObjectURL(new Blob([HTML], {
       type: "text/html"
    }));
  }														  
													  
															  
  function createCSSObjectURL(css){
     return URL.createObjectURL(new Blob([css], {
       type: "text/css"
    }));
  }														  
				
  function __createObjectURL(type, content){
	 if(false!==frdl.strpos(type, 'script')){
	   return frdl.createJavascriptObjectURL(content);										  
	}												  
													  
     return URL.createObjectURL(new Blob([content], {
       type: type
    }));
  }														  
													  
		
 function dashToCamel(dash) {
        return dash.indexOf('-') < 0 ? dash : dash.replace(/-[a-z]/g, function (m) {
          return m[1].toUpperCase();
        });
 }


 function camelToDash(camel) {
        return camel.replace(/([A-Z])/g, '-$1').toLowerCase();
  }

function dechex (number) {
  if (number < 0) {
    number = 0xFFFFFFFF + number + 1;
  }
  return parseInt(number, 10)
    .toString(16);
}

function hexdec (hexString) {
  hexString = (hexString + '').replace(/[^a-f0-9]/gi, '');
  return parseInt(hexString, 16);
}


function stripslashes (str) {
  /*!       discuss at: http://locutus.io/php/stripslashes/ */
  /*      original by: Kevin van Zonneveld (http://kvz.io)
  //      improved by: Ates Goral (http://magnetiq.com)
  //      improved by: marrtins
  //      improved by: rezna
  //         fixed by: Mick@el
  //      bugfixed by: Onno Marsman (https://twitter.com/onnomarsman)
  //      bugfixed by: Brett Zamir (http://brett-zamir.me)
  //         input by: Rick Waldron
  //         input by: Brant Messenger (http://www.brantmessenger.com/)
  // reimplemented by: Brett Zamir (http://brett-zamir.me)
  //        example 1: stripslashes('Kevin\'s code')
  //        returns 1: "Kevin's code"
  //        example 2: stripslashes('Kevin\\\'s code')
  //        returns 2: "Kevin\'s code"
  */
  return (str + '')
    .replace(/\\(.?)/g, function (s, n1) {
      switch (n1) {
        case '\\':
          return '\\';
        case '0':
          return '\u0000';
        case '':
          return '';
        default:
          return n1;
      }
    });
}

	
	




function ucfirst (str) {
  //  discuss at: http://locutus.io/php/ucfirst/
  // original by: Kevin van Zonneveld (http://kvz.io)
  // bugfixed by: Onno Marsman (https://twitter.com/onnomarsman)
  // improved by: Brett Zamir (http://brett-zamir.me)
  //   example 1: ucfirst('kevin van zonneveld')
  //   returns 1: 'Kevin van zonneveld'

  str += '';
  var f = str.charAt(0)
    .toUpperCase();
  return f + str.substr(1);
}

/*! http://locutus.io/php */

            function str_replace(search, replace, subject) {
                if ('string' !== typeof subject)
                    return '';
                try {
                    return subject.split(search).join(replace);
                } catch (err) {
                        console.warn(err);
                    return '';
                }
            }
	
function preg_quote (str, delimiter) {


    // Quote regular expression characters plus an optional character  
    // 
    // version: 1107.2516
    // discuss at: http://phpjs.org/functions/preg_quote
    // +   original by: booeyOH
    // +   improved by: Ates Goral (http://magnetiq.com)
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   bugfixed by: Onno Marsman
    // +   improved by: Brett Zamir (http://brett-zamir.me)
    // *     example 1: preg_quote("$40");
    // *     returns 1: '\$40'
    // *     example 2: preg_quote("*RRRING* Hello?");
    // *     returns 2: '\*RRRING\* Hello\?'
    // *     example 3: preg_quote("\\.+*?[^]$(){}=!<>|:");
    // *     returns 3: '\\\.\+\*\?\[\^\]\$\(\)\{\}\=\!\<\>\|\:'
    
    return (str + '').replace(new RegExp('[.\\\\+*?\\[\\^\\]$(){}=!<>|:\\' + (delimiter || '') + '-]', 'g'), '\\$&')
               //     .replace(/(\s)/, "\s")
;
}

 function explode(delimiter, string, limit) {
                if (arguments.length < 2 || typeof delimiter === 'undefined' || typeof string === 'undefined')
                    return null;
                if (delimiter === '' || delimiter === false || delimiter === null)
                    return false;
                if (typeof delimiter === 'function' || typeof delimiter === 'object' || typeof string === 'function' || typeof string === 'object') {
                    return [0];
                }
                if (delimiter === true)
                    delimiter = '1';
                delimiter += '';
                string += '';
                var s = string.split(delimiter);
                if (typeof limit === 'undefined')
                    return s;
                if (limit === 0)
                    limit = 1;
                if (limit > 0) {
                    if (limit >= s.length)
                        return s;
                    return s.slice(0, limit - 1).concat([s.slice(limit - 1).join(delimiter)]);
                }
                if (-limit >= s.length)
                    return [];
                s.splice(s.length + limit);
                return s;
 }



function base64_encode(data) {
                var b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
                var o1, o2, o3, h1, h2, h3, h4, bits, i = 0,
                    ac = 0,
                    enc = "",
                    tmp_arr = [];
                if (!data) {
                    return data;
                }
                do {
                    o1 = data.charCodeAt(i++);
                    o2 = data.charCodeAt(i++);
                    o3 = data.charCodeAt(i++);
                    bits = o1 << 16 | o2 << 8 | o3;
                    h1 = bits >> 18 & 0x3f;
                    h2 = bits >> 12 & 0x3f;
                    h3 = bits >> 6 & 0x3f;
                    h4 = bits & 0x3f;
                    tmp_arr[ac++] = b64.charAt(h1) + b64.charAt(h2) + b64.charAt(h3) + b64.charAt(h4);
                } while (i < data.length);
                enc = tmp_arr.join('');
                var r = data.length % 3;
                return (r ? enc.slice(0, r - 3) : enc) + '==='.slice(r || 3);
            }	


function base64_detect(str) {
                var base64Detect = new RegExp("^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{4})$");
                if (base64Detect.test(str)) {
                    return true;
                } else {
                    return false;
                }
}



function base64_decode(data) {
                var b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
                var o1, o2, o3, h1, h2, h3, h4, bits, i = 0,
                    ac = 0,
                    dec = "",
                    tmp_arr = [];
                if (!data) {
                    return data;
                }
                data += '';
                do {
                    h1 = b64.indexOf(data.charAt(i++));
                    h2 = b64.indexOf(data.charAt(i++));
                    h3 = b64.indexOf(data.charAt(i++));
                    h4 = b64.indexOf(data.charAt(i++));
                    bits = h1 << 18 | h2 << 12 | h3 << 6 | h4;
                    o1 = bits >> 16 & 0xff;
                    o2 = bits >> 8 & 0xff;
                    o3 = bits & 0xff;
                    if (h3 == 64) {
                        tmp_arr[ac++] = global.String.fromCharCode(o1);
                    } else if (h4 == 64) {
                        tmp_arr[ac++] = global.String.fromCharCode(o1, o2);
                    } else {
                        tmp_arr[ac++] = global.String.fromCharCode(o1, o2, o3);
                    }
                } while (i < data.length);
                dec = tmp_arr.join('');
                return dec;
 }



function addMethodCallback(obj, originalMethodName, $returns, callBackMethod, context){
            var fnOriginal = obj[originalMethodName],
                outcome;

            context = context || obj;
																						  
        if(!!$returns){
																						  
            obj[originalMethodName] = function () {
                var outcome = fnOriginal.apply(this, arguments);

                outcome = extend(outcome, callBackMethod.apply(this, arguments) || {});

                return outcome;
            };
																						  
        }else{
	          obj[originalMethodName] = function () {
                var outcome = fnOriginal.apply(this, arguments);

                  callBackMethod.apply(this, arguments);

                return outcome;
            };
																										  
	    }
}

function extractTextBetween(subject, start, end) {
    try{
        return subject.split(start)[1].split(end)[0];
    } catch(e){
        console.log("Exception when extracting text", e);
		return false;
    }
}